diff a/test/langtools/tools/javac/records/RecordReading.java b/test/langtools/tools/javac/records/RecordReading.java
--- a/test/langtools/tools/javac/records/RecordReading.java
+++ b/test/langtools/tools/javac/records/RecordReading.java
@@ -1,7 +1,7 @@
 /*
- * Copyright (c) 2020, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2020, 2021, Oracle and/or its affiliates. All rights reserved.
  * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
  *
  * This code is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License version 2 only, as
  * published by the Free Software Foundation.
@@ -23,21 +23,22 @@
 
 /*
  * @test
  * @summary test the records can be read by javac properly
  * @library /tools/lib
+ * @bug 8273018
  * @modules jdk.compiler/com.sun.tools.javac.api
  *          jdk.compiler/com.sun.tools.javac.main
  * @build toolbox.ToolBox toolbox.JavacTask
  * @run main RecordReading
  */
 
-
 import java.io.IOException;
 import java.nio.file.Files;
 import java.nio.file.Path;
 import java.nio.file.Paths;
+import java.util.List;
 import java.util.Objects;
 import toolbox.TestRunner;
 import toolbox.ToolBox;
 import toolbox.JavacTask;
 import toolbox.Task;
@@ -123,7 +124,6 @@
                 """;
         if (!Objects.equals(expected, output)) {
             throw new AssertionError("Unexpected output: " + output);
         }
     }
-
 }
diff a/test/langtools/tools/javac/unnamed/UnnamedLocalVariableTable.java b/test/langtools/tools/javac/unnamed/UnnamedLocalVariableTable.java
--- a/test/langtools/tools/javac/unnamed/UnnamedLocalVariableTable.java
+++ b/test/langtools/tools/javac/unnamed/UnnamedLocalVariableTable.java
@@ -26,10 +26,11 @@
  * @bug 8313323
  * @summary Verify javac does not produce incorrect LocalVariableTable
  * @enablePreview
  * @compile -g UnnamedLocalVariableTable.java
  * @run main UnnamedLocalVariableTable
+ * @ignore Verifier error
  */
 public class UnnamedLocalVariableTable {
     public static void main(String... args) {
         try {
             int _ = 0;
diff a/test/langtools/tools/javac/valhalla/value-objects/ArrayCreationWithQuestion.java b/test/langtools/tools/javac/valhalla/value-objects/ArrayCreationWithQuestion.java
--- /dev/null
+++ b/test/langtools/tools/javac/valhalla/value-objects/ArrayCreationWithQuestion.java
@@ -0,0 +1,84 @@
+/*
+ * Copyright (c) 2019, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+
+/*
+ * @test
+ * @bug 8222634
+ * @summary Check array creation with value classes
+ * @modules jdk.compiler/com.sun.tools.javac.util jdk.jdeps/com.sun.tools.javap
+ * @modules jdk.compiler
+ * @compile --enable-preview -source ${jdk.version} ArrayCreationWithQuestion.java
+ * @run main/othervm --enable-preview ArrayCreationWithQuestion
+ */
+
+import java.io.PrintWriter;
+import java.io.StringWriter;
+import java.nio.file.Paths;
+
+public class ArrayCreationWithQuestion {
+
+    static value class VT {
+        VT[] a1;
+        VT[] a2;
+
+        VT() {
+            a1 = new VT[42];
+            a2 = new VT[42];
+        }
+    }
+
+    public static void main(String[] args) {
+        new ArrayCreationWithQuestion().run();
+    }
+
+    void run() {
+        String [] params = new String [] { "-v",
+                Paths.get(System.getProperty("test.classes"),
+                        "ArrayCreationWithQuestion$VT.class").toString() };
+        runCheck(params, new String [] {
+                "         3: anewarray     #1                  // class ArrayCreationWithQuestion$VT",
+                "        12: anewarray     #1                  // class ArrayCreationWithQuestion$VT",
+        });
+
+    }
+
+    void runCheck(String [] params, String [] expectedOut) {
+        StringWriter s;
+        String out;
+
+        try (PrintWriter pw = new PrintWriter(s = new StringWriter())) {
+            com.sun.tools.javap.Main.run(params, pw);
+            out = s.toString();
+        }
+        int errors = 0;
+        for (String eo: expectedOut) {
+            if (!out.contains(eo)) {
+                System.err.println("Match not found for string: " + eo);
+                errors++;
+            }
+        }
+        if (errors > 0) {
+            throw new AssertionError("Unexpected javap output: " + out);
+        }
+    }
+}
diff a/test/langtools/tools/javac/valhalla/value-objects/AsSuperTests.java b/test/langtools/tools/javac/valhalla/value-objects/AsSuperTests.java
--- /dev/null
+++ b/test/langtools/tools/javac/valhalla/value-objects/AsSuperTests.java
@@ -0,0 +1,74 @@
+/*
+ * Copyright (c) 2021, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.  Oracle designates this
+ * particular file as subject to the "Classpath" exception as provided
+ * by Oracle in the LICENSE file that accompanied this code.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+
+/*
+ * @test
+ * @bug 8244712
+ * @summary Javac should switch to reference projection before walking type hierarchy.
+ * @enablePreview
+ * @compile AsSuperTests.java
+ */
+
+/* The following test "covers"/verifies that the asSuper calls in
+   com.sun.tools.javac.comp.Resolve#resolveSelf &&
+   com.sun.tools.javac.comp.Lower#visitSelect
+   com.sun.tools.javac.comp.Resolve#mostSpecific
+   com.sun.tools.javac.comp.Attr#visitSelect
+   com.sun.tools.javac.comp.Resolve.UnboundMethodReferenceLookupHelper#UnboundMethodReferenceLookupHelper
+   work correctly with value classes.
+*/
+
+interface I {
+    default void foo() {
+        System.out.println("I.foo");
+    }
+}
+
+abstract value class Base<T> {
+    static void goo() {}
+    void zoo() {}
+    interface SAM {
+       String m(Foo f);
+    }
+
+    static void test() {
+        SAM s = Base::getX;
+    }
+
+    String getX() { return null; }
+
+    static value class Foo<X> extends Base {}
+}
+
+value class X extends Base implements I {
+
+    static void goo() {}
+
+    public void foo() {
+        I.super.foo();
+        X.this.goo(); // covers the asSuper call in com.sun.tools.javac.comp.Resolve#mostSpecific
+        super.zoo();  // covers the asSuper call in com.sun.tools.javac.comp.Attr#visitSelect
+    }
+}
diff a/test/langtools/tools/javac/valhalla/value-objects/CanonicalCtorTest.java b/test/langtools/tools/javac/valhalla/value-objects/CanonicalCtorTest.java
--- /dev/null
+++ b/test/langtools/tools/javac/valhalla/value-objects/CanonicalCtorTest.java
@@ -0,0 +1,68 @@
+/*
+ * Copyright (c) 2018, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+
+/**
+ * @test
+ * @bug 8208067
+ * @enablePreview
+ * @summary Verify that instance methods are callable from ctor after all instance fields are DA.
+ */
+
+public value class CanonicalCtorTest {
+
+    private final int x, ymx;
+
+    CanonicalCtorTest(int x, int y) {
+
+        ymx = y - x;
+        this.x = x;
+
+        // all fields are assigned now, but we need a explicit `super()` invocation before accessing `this`
+        super();
+
+        validate();                 // OK: DU = {}
+        this.validate();            // OK: DU = {}
+        CanonicalCtorTest.this.validate();          // OK: DU = {}
+
+        assert (this.x > 0);        // OK: DU = {}
+        assert (this.y() > 0);      // OK: DU = {}
+    }
+
+    int x() {
+        return x;
+    }
+
+    int y() {
+        return ymx + x;
+    }
+
+    void validate() {
+        assert (x() > 0 && y() > 0);
+    }
+
+    public static void main(String... av) {
+        CanonicalCtorTest z = new CanonicalCtorTest(1, 10);
+        assert (z.x() == 1);
+        assert (z.y() == 10);
+    }
+}
diff a/test/langtools/tools/javac/valhalla/value-objects/CheckSynchronized.java b/test/langtools/tools/javac/valhalla/value-objects/CheckSynchronized.java
--- /dev/null
+++ b/test/langtools/tools/javac/valhalla/value-objects/CheckSynchronized.java
@@ -0,0 +1,44 @@
+/*
+ * @test /nodynamiccopyright/
+ * @summary Check behavior of synzhronized key word on value classes instances and methods.
+ * @enablePreview
+ * @compile/fail/ref=CheckSynchronized.out -XDrawDiagnostics CheckSynchronized.java
+ */
+
+value final class CheckSynchronized implements java.io.Serializable {
+    synchronized void foo() { // <<-- ERROR, no monitor associated with `this'
+    }
+    void goo() {
+        synchronized(this) {} // <<-- ERROR, no monitor associated with `this'
+    }
+    synchronized static void zoo(CheckSynchronized cs) { // OK, static method.
+        synchronized(cs) {    // <<-- ERROR, no monitor associated with value class instance.
+        }
+
+        CheckSynchronized csr = cs;
+        synchronized(csr) {
+            // Error, no identity.
+        }
+
+        synchronized(x) {
+            // Error, no identity.
+        }
+
+        Object o = cs;
+        synchronized(o) {
+            // Error BUT not discernible at compile time
+        }
+        java.io.Serializable jis = cs;
+        synchronized(jis) {
+            // Error BUT not discernible at compile time
+        }
+    }
+    static int x = 10;
+
+    value record CheckSynchronizedRecord(int x, int y) {
+        synchronized void foo() { // <<-- ERROR, no monitor associated with `this'
+        }
+        synchronized static void zoo() { // OK, static method.
+        }
+    }
+}
diff a/test/langtools/tools/javac/valhalla/value-objects/ConstructorRefTest.java b/test/langtools/tools/javac/valhalla/value-objects/ConstructorRefTest.java
--- /dev/null
+++ b/test/langtools/tools/javac/valhalla/value-objects/ConstructorRefTest.java
@@ -0,0 +1,73 @@
+/*
+ * Copyright (c) 2022, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.  Oracle designates this
+ * particular file as subject to the "Classpath" exception as provided
+ * by Oracle in the LICENSE file that accompanied this code.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+
+/*
+ * @test
+ * @bug 8281166
+ * @summary javac should generate BSM to invoke constructor for value class
+ * @enablePreview
+ * @compile ConstructorRefTest.java
+ * @run main/othervm ConstructorRefTest
+ */
+
+import java.util.function.Supplier;
+
+public class ConstructorRefTest {
+
+    public static value class V {
+
+        final int x;
+        final int y;
+
+        V() {
+            x = 1234;
+            y = 5678;
+        }
+    }
+
+    public static class P {
+
+        final int x;
+        final int y;
+
+        P() {
+            x = 1234;
+            y = 5678;
+        }
+    }
+
+    public static void main(String [] args) {
+
+        Supplier<P> sxp = P::new;
+        P p = (P) sxp.get();
+        if (p.x != 1234 || p.y != 5678)
+            throw new AssertionError(p);
+
+        Supplier<V> sxv = V::new;
+        V v = (V) sxv.get();
+        if (v.x != 1234 || v.y != 5678)
+            throw new AssertionError(v);
+    }
+}
diff a/test/langtools/tools/javac/valhalla/value-objects/DualNonDuplicateErrors.java b/test/langtools/tools/javac/valhalla/value-objects/DualNonDuplicateErrors.java
--- /dev/null
+++ b/test/langtools/tools/javac/valhalla/value-objects/DualNonDuplicateErrors.java
@@ -0,0 +1,26 @@
+/*
+ * @test /nodynamiccopyright/
+ * @bug 8267843
+ * @summary Check that javac diagnoses `this` being passed around and instance method being invoked before value class instance is fully initialized.
+ * @enablePreview
+ * @compile/fail/ref=DualNonDuplicateErrors.out -XDrawDiagnostics DualNonDuplicateErrors.java
+ */
+
+public value class DualNonDuplicateErrors {
+
+    int x;
+
+    DualNonDuplicateErrors() {
+        // The call below should trigger two errors - they are not duplicates really.
+        // First one is for `this` being passed around ("exposed")
+        // Second is for instance method being invoked thereby allowing that method to
+        // observe the value class instance in a partially initialized state.
+        foo(this);
+        x = 10;
+        super();
+        foo(this); // No error here.
+    }
+
+    void foo(DualNonDuplicateErrors x) {
+    }
+}
diff a/test/langtools/tools/javac/valhalla/value-objects/GenericPoint.java b/test/langtools/tools/javac/valhalla/value-objects/GenericPoint.java
--- /dev/null
+++ b/test/langtools/tools/javac/valhalla/value-objects/GenericPoint.java
@@ -0,0 +1,32 @@
+/*
+ * Copyright (c) 2022, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+
+public value class GenericPoint<T> {
+
+    T x, y;
+
+    GenericPoint(T x, T y) {
+        this.x = x;
+        this.y = y;
+    }
+}
diff a/test/langtools/tools/javac/valhalla/value-objects/IllegalMonitorStateExceptionTest.java b/test/langtools/tools/javac/valhalla/value-objects/IllegalMonitorStateExceptionTest.java
--- /dev/null
+++ b/test/langtools/tools/javac/valhalla/value-objects/IllegalMonitorStateExceptionTest.java
@@ -0,0 +1,46 @@
+/*
+ * Copyright (c) 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+
+/*
+ * @test
+ * @bug 8329400
+ * @summary test to check that IllegalMonitorStateException is thrown for value objects
+ * @enablePreview
+ * @run main IllegalMonitorStateExceptionTest
+ */
+
+public value class IllegalMonitorStateExceptionTest {
+    void m(Object o) {
+        synchronized (o) {}
+    }
+
+    public static void main(String[] args) throws Exception {
+        IllegalMonitorStateExceptionTest v = new IllegalMonitorStateExceptionTest();
+        try {
+            v.m(v);
+            throw new AssertionError("should have failed with IllegalMonitorStateExceptionTest");
+        } catch (IllegalMonitorStateException e) {
+            // as expected
+        }
+    }
+}
diff a/test/langtools/tools/javac/valhalla/value-objects/NoUnnecessaryPreloadsTest.java b/test/langtools/tools/javac/valhalla/value-objects/NoUnnecessaryPreloadsTest.java
--- /dev/null
+++ b/test/langtools/tools/javac/valhalla/value-objects/NoUnnecessaryPreloadsTest.java
@@ -0,0 +1,128 @@
+/*
+ * Copyright (c) 2022, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+
+/*
+ * @test
+ * @bug 8281323
+ * @summary Check emission of Preload attribute to make sure javac does not emit unneeded entries.
+ * @modules jdk.jdeps/com.sun.tools.classfile
+ * @enablePreview
+ * @run main NoUnnecessaryPreloadsTest
+ */
+
+import com.sun.tools.classfile.*;
+import com.sun.tools.classfile.ConstantPool.CONSTANT_Class_info;
+
+public class NoUnnecessaryPreloadsTest {
+
+    public value class PreLoadTest1 {
+        byte b;
+        public PreLoadTest1(byte b) {
+            this.b = b;
+        }
+    }
+
+    public class PreLoadTest2 {
+        static class Inner1 {
+            static value class Inner2 {}
+            Inner2 inner;
+        }
+    }
+
+    public static void main(String[] args) throws Exception {
+
+        // There should be no Preload attribute in NoUnnecessaryPreloadsTest.class
+        ClassFile cls = ClassFile.read(NoUnnecessaryPreloadsTest.class.getResourceAsStream("NoUnnecessaryPreloadsTest.class"));
+
+        if (cls == null) {
+            throw new AssertionError("Could not locate the class files");
+        }
+
+        /* Check emission of Preload attribute */
+        Preload_attribute preloads = (Preload_attribute) cls.attributes.get(Attribute.Preload);
+        if (preloads != null) {
+            throw new AssertionError("Unexpected Preload attribute!");
+        }
+
+        // There should be no Preload attribute in NoUnnecessaryPreloadsTest$PreloadTest1.class
+        cls = ClassFile.read(NoUnnecessaryPreloadsTest.class.getResourceAsStream("NoUnnecessaryPreloadsTest$PreLoadTest1.class"));
+
+        if (cls == null) {
+            throw new AssertionError("Could not locate the class files");
+        }
+
+        /* Check emission of Preload attribute */
+        preloads = (Preload_attribute) cls.attributes.get(Attribute.Preload);
+        if (preloads != null) {
+            throw new AssertionError("Unexpected Preload attribute!");
+        }
+
+        // There should be no Preload attribute in NoUnnecessaryPreloadsTest$PreloadTest2.class
+        cls = ClassFile.read(NoUnnecessaryPreloadsTest.class.getResourceAsStream("NoUnnecessaryPreloadsTest$PreLoadTest2.class"));
+
+        if (cls == null) {
+            throw new AssertionError("Could not locate the class files");
+        }
+
+        /* Check emission of Preload attribute */
+        preloads = (Preload_attribute) cls.attributes.get(Attribute.Preload);
+        if (preloads != null) {
+            throw new AssertionError("Unexpected Preload attribute!");
+        }
+
+        // There should be no Preload attribute in NoUnnecessaryPreloadsTest$PreloadTest2$Inner2.class
+        cls = ClassFile.read(NoUnnecessaryPreloadsTest.class.getResourceAsStream("NoUnnecessaryPreloadsTest$PreLoadTest2$Inner1$Inner2.class"));
+
+        if (cls == null) {
+            throw new AssertionError("Could not locate the class files");
+        }
+
+        /* Check emission of Preload attribute */
+        preloads = (Preload_attribute) cls.attributes.get(Attribute.Preload);
+        if (preloads != null) {
+            throw new AssertionError("Unexpected Preload attribute!");
+        }
+
+        // There should be ONE Preload attribute entry in NoUnnecessaryPreloadsTest$PreloadTest2$Inner1.class
+        cls = ClassFile.read(NoUnnecessaryPreloadsTest.class.getResourceAsStream("NoUnnecessaryPreloadsTest$PreLoadTest2$Inner1.class"));
+
+        if (cls == null) {
+            throw new AssertionError("Could not locate the class files");
+        }
+
+        /* Check emission of Preload attribute */
+        preloads = (Preload_attribute) cls.attributes.get(Attribute.Preload);
+        if (preloads == null) {
+            throw new AssertionError("Missing Preload attribute!");
+        }
+
+        if (preloads.number_of_classes != 1) {
+            throw new AssertionError("Incorrect number of Preload classes");
+        }
+
+        CONSTANT_Class_info clsInfo = cls.constant_pool.getClassInfo(preloads.value_class_info_index[0]);
+        if (!clsInfo.getName().equals("NoUnnecessaryPreloadsTest$PreLoadTest2$Inner1$Inner2")) {
+            throw new AssertionError("Expected Preload class entry is missing, but found " + clsInfo.getName());
+        }
+    }
+}
diff a/test/langtools/tools/javac/valhalla/value-objects/PreloadAttrTest2.java b/test/langtools/tools/javac/valhalla/value-objects/PreloadAttrTest2.java
--- /dev/null
+++ b/test/langtools/tools/javac/valhalla/value-objects/PreloadAttrTest2.java
@@ -0,0 +1,110 @@
+/*
+ * Copyright (c) 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+
+/*
+ * @test
+ * @bug 8331461
+ * @summary [lworld] javac is generating a class file with the Preload attribute but with minor version '0'
+ * @library /tools/lib
+ * @modules
+ *      jdk.compiler/com.sun.tools.javac.code
+ *      jdk.compiler/com.sun.tools.javac.util
+ *      jdk.compiler/com.sun.tools.javac.api
+ *      jdk.compiler/com.sun.tools.javac.file
+ *      jdk.compiler/com.sun.tools.javac.main
+ *      jdk.jdeps/com.sun.tools.classfile
+ * @build toolbox.ToolBox toolbox.JavacTask
+ * @run main PreloadAttrTest2
+ */
+
+import java.nio.file.Path;
+import java.nio.file.Paths;
+
+import com.sun.tools.javac.code.Flags;
+import com.sun.tools.javac.util.Assert;
+import com.sun.tools.classfile.ClassFile;
+
+import toolbox.TestRunner;
+import toolbox.ToolBox;
+import toolbox.JavacTask;
+import toolbox.Task;
+
+public class PreloadAttrTest2 extends TestRunner {
+    ToolBox tb = new ToolBox();
+
+    public PreloadAttrTest2() {
+        super(System.err);
+    }
+
+    protected void runTests() throws Exception {
+        runTests(m -> new Object[] { Paths.get(m.getName()) });
+    }
+
+    Path[] findJavaFiles(Path... paths) throws Exception {
+        return tb.findJavaFiles(paths);
+    }
+
+    public static void main(String... args) throws Exception {
+        new PreloadAttrTest2().runTests();
+    }
+
+    @Test
+    public void testValueBased(Path base) throws Exception {
+        Path src = base.resolve("src");
+        tb.writeJavaFiles(src,
+                """
+                value class Val {}
+                """,
+                """
+                class Ident {
+                    Val val;
+                }
+                """);
+        Path classes = base.resolve("classes");
+        tb.createDirectories(classes);
+
+        new toolbox.JavacTask(tb)
+                .options("--enable-preview", "-source", Integer.toString(Runtime.version().feature()))
+                .outdir(classes)
+                .files(findJavaFiles(src))
+                .run()
+                .writeAll();
+        Path classFilePath = classes.resolve("Ident.class");
+        ClassFile classFile = ClassFile.read(classFilePath.toFile());
+        Assert.check(classFile.minor_version == 65535);
+        Assert.check(classFile.attributes.get("Preload") != null);
+
+        // now with the value class in the classpath
+        new toolbox.JavacTask(tb)
+                .options("--enable-preview", "-source", Integer.toString(Runtime.version().feature()), "-cp", classes.toString())
+                .outdir(classes)
+                .files(src.resolve("Ident.java"))
+                .run()
+                .writeAll();
+
+        classFilePath = classes.resolve("Ident.class");
+        classFile = ClassFile.read(classFilePath.toFile());
+        Assert.check(classFile.minor_version == 65535);
+        Assert.check(classFile.attributes.get("Preload") != null);
+    }
+}
